## ros-iron-plansys2-executor 2.0.11

=== CMakeLists.txt ===
project(plansys2_executor)

cmake_minimum_required(VERSION 3.5)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(rclcpp_cascade_lifecycle REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(plansys2_core REQUIRED)
find_package(plansys2_pddl_parser REQUIRED)
find_package(plansys2_msgs REQUIRED)
find_package(plansys2_domain_expert REQUIRED)
find_package(plansys2_problem_expert REQUIRED)
find_package(plansys2_planner REQUIRED)
find_package(pluginlib REQUIRED)
find_package(behaviortree_cpp_v3 REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)

find_package(ZMQ)
if(ZMQ_FOUND)
    message(STATUS "ZeroMQ found.")
    add_definitions(-DZMQ_FOUND)
else()
  message(WARNING "ZeroMQ NOT found. Not including PublisherZMQ.")
endif()

set(CMAKE_CXX_STANDARD 17)

set(dependencies
    rclcpp
    rclcpp_lifecycle
    lifecycle_msgs
    rclcpp_cascade_lifecycle
    rclcpp_action
    plansys2_pddl_parser
    ament_index_cpp
    plansys2_core
    plansys2_msgs
    plansys2_domain_expert
    plansys2_problem_expert
    plansys2_planner
    pluginlib
    behaviortree_cpp_v3
    std_msgs
    std_srvs
)

include_directories(include ${ZMQ_INCLUDE_DIRS})

set(EXECUTOR_SOURCES
  src/plansys2_executor/ExecutorClient.cpp
  src/plansys2_executor/ActionExecutor.cpp
  src/plansys2_executor/ActionExecutorClient.cpp
  src/plansys2_executor/ExecutorNode.cpp
  src/plansys2_executor/ComputeBT.cpp
  src/plansys2_executor/behavior_tree/execute_action_node.cpp
  src/plansys2_executor/behavior_tree/wait_action_node.cpp
  src/plansys2_executor/behavior_tree/check_action_node.cpp
  src/plansys2_executor/behavior_tree/wait_atstart_req_node.cpp
  src/plansys2_executor/behavior_tree/check_overall_req_node.cpp
  src/plansys2_executor/behavior_tree/check_atend_req_node.cpp
  src/plansys2_executor/behavior_tree/check_timeout_node.cpp
  src/plansys2_executor/behavior_tree/apply_atstart_effect_node.cpp
  src/plansys2_executor/behavior_tree/apply_atend_effect_node.cpp
)


add_library(${PROJECT_NAME} SHARED ${EXECUTOR_SOURCES})
ament_target_dependencies(${PROJECT_NAME} ${dependencies})
target_link_libraries(${PROJECT_NAME} ${ZMQ_LIBRARIES})

add_executable(executor_node
  src/executor_node.cpp
)
ament_target_dependencies(executor_node ${dependencies})
target_link_libraries(executor_node ${PROJECT_NAME})

add_executable(compute_bt
  src/compute_bt.cpp
)
ament_target_dependencies(compute_bt ${dependencies})
target_link_libraries(compute_bt ${PROJECT_NAME})

install(DIRECTORY include/
  DESTINATION include/
)

add_library(bt_builder_plugins SHARED
  src/plansys2_executor/bt_builder_plugins/simple_bt_builder.cpp
  src/plansys2_executor/bt_builder_plugins/stn_bt_builder.cpp
)
ament_target_dependencies(bt_builder_plugins ${dependencies})

pluginlib_export_plugin_description_file(plansys2_executor plugins.xml)

install(DIRECTORY launch behavior_trees DESTINATION share/${PROJECT_NAME})

install(TARGETS
  ${PROJECT_NAME}
  bt_builder_plugins
  executor_node
  compute_bt
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest REQUIRED)

  add_subdirectory(test)
endif()

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME} bt_builder_plugins)
ament_export_dependencies(${dependencies})

ament_package()

=== test/unit/CMakeLists.txt ===
ament_add_gtest(executor_test executor_test.cpp TIMEOUT 300)
target_compile_definitions(executor_test
  PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(executor_test ${PROJECT_NAME})

ament_add_gtest(action_execution_test action_execution_test.cpp)
target_compile_definitions(action_execution_test
  PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(action_execution_test ${PROJECT_NAME})


ament_add_gtest(execution_tree_test execution_tree_test.cpp)
target_compile_definitions(execution_tree_test
  PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(execution_tree_test ${PROJECT_NAME})
ament_target_dependencies(execution_tree_test ${dependencies})

ament_add_gtest(simple_btbuilder_tests simple_btbuilder_tests.cpp)
target_compile_definitions(simple_btbuilder_tests
  PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(simple_btbuilder_tests ${PROJECT_NAME} bt_builder_plugins)
ament_target_dependencies(simple_btbuilder_tests ${dependencies})

ament_add_gtest(bt_node_test bt_node_test.cpp)
target_compile_definitions(bt_node_test
  PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(bt_node_test ${PROJECT_NAME})
ament_target_dependencies(bt_node_test ${dependencies})

ament_add_gtest(bt_node_test_charging bt_node_test_charging.cpp)
target_compile_definitions(bt_node_test_charging
  PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
target_link_libraries(bt_node_test_charging ${PROJECT_NAME})
ament_target_dependencies(bt_node_test_charging ${dependencies})

=== debian/changelog ===
ros-iron-plansys2-executor (2.0.11-1jammy) jammy; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Tue, 01 Aug 2023 22:00:00 -0000

ros-iron-plansys2-executor (2.0.10-1jammy) jammy; urgency=high

  * Merge remote-tracking branch 'origin/humble-devel'
  * Merge pull request #252 <https://github.com/PlanSys2/ros2_planning_system/issues/252> from PlanSys2/check_at_end
    Check at end reqs in bt builder
  * Check at end reqs in bt builder
  * Merge pull request #251 <https://github.com/PlanSys2/ros2_planning_system/issues/251> from PlanSys2/fix_bt_node
    Fix bt node
  * Change MultiThreaded for SingleThreaded in CI failing tests
  * Change double quotes for simple ones (linter)
  * Insert in blackboard the action ROS 2 Node
  * Merge pull request #247 <https://github.com/PlanSys2/ros2_planning_system/issues/247> from jjzapf/standalone-bt-builder
    Standalone BT Builder Service
  * Fixing cpplint warning.
  * Fixing cpplint warnings.
  * Checking for self-referencing edges in STNBTBuilder. Adding standalone compute_bt service.
  * Merge remote-tracking branch 'origin/master' into fix_goal_structure_issue_205
  * Merge pull request #240 <https://github.com/PlanSys2/ros2_planning_system/issues/240> from jjzapf/bt-builder-plugins
    New BT Builder and Plugin Interface
  * bt-builder-plugins: Setting default BT builder plugin to SimpleBTBuilder.
  * bt-builder-plugins: Creating BT builder plugin interface. Moving current BT builder to plugin named SimpleBTBuilder. Adding new and improved STN-based BT builder plugin named STNBTBuilder.
  * Merge remote-tracking branch 'origin/master' into fix_goal_structure_issue_205
  * Merge remote-tracking branch 'upstream/master'
  * Merge branch 'IntelligentRoboticsLabs:master' into master
  * Contributors: Andrianov Roman, Francisco Martín Rico, Josh Zapf, Marco Roveri, Splinter1984

 -- Francisco Martin Rico <fmrico@gmail.com>  Sun, 16 Jul 2023 22:00:00 -0000

ros-iron-plansys2-executor (2.0.9-1jammy) jammy; urgency=high

  * Humble Upgrade
  * Fix possible bug https://github.com/ros2/rclcpp/issues/1968
  * Expose lifecyclemanager timeout as a parameter, other misc fixes/features
  * Linters are explicit
  * Add ctor to ExecutorClient for varying node name
  * Fix uninitialized variable in ExecutorClient
  * Contributors: Francisco Martín Rico, Jake Keller

 -- Francisco Martin Rico <fmrico@gmail.com>  Sat, 09 Jul 2022 22:00:00 -0000

ros-iron-plansys2-executor (2.0.8-1jammy) jammy; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Tue, 03 May 2022 22:00:00 -0000

ros-iron-plansys2-executor (2.0.7-1jammy) jammy; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Tue, 03 May 2022 22:00:00 -0000

ros-iron-plansys2-executor (2.0.6-1jammy) jammy; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Mon, 02 May 2022 22:00:00 -0000

ros-iron-plansys2-executor (2.0.5-1jammy) jammy; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Mon, 02 May 2022 22:00:00 -0000

ros-iron-plansys2-executor (2.0.4-1jammy) jammy; urgency=high

  * Fix version
  * Merge pull request #223 <https://github.com/IntelligentRoboticsLabs/ros2_planning_system/issues/223> from IntelligentRoboticsLabs/fix_threads_buildfarm
    Fix threads buildfarm
  * Fix ROS2 Buildfarm error due to Threads
  * Merge pull request #217 <https://github.com/IntelligentRoboticsLabs/ros2_planning_system/issues/217> from jjzapf/check-action-finished
    Check action finished
  * check-action-finished: Putting leftover requirement check after state update in get_graph function.
  * check-action-finished: Use distinct names for temporary predicate/function variables inside of while loop.
  * check-action-finished: Reverting previous changes. Adding checks to WaitAction node to verify that action has finished.
  * check-action-finished: Fixing problem_expert.wait_overall_req_test in plansys2_executor/bt_node_test.cpp.
  * check-action-finished: Do not declare failure in check_overall_req_node if action has already finished.
  * Merge pull request #209 <https://github.com/IntelligentRoboticsLabs/ros2_planning_system/issues/209> from sarcasticnature/master
    Improvements on recent BtActionNode changes
  * Merge pull request #216 <https://github.com/IntelligentRoboticsLabs/ros2_planning_system/issues/216> from jjzapf/action-graph-bug-fix
    Plan-to-Action Graph Bug Fix
  * action-graph-bug-fix: Not applying at end effects when testing if actions can be run in parallel. Fixing bug in prune_backwards function.
  * Update unit tests to match changes
  * Remove extra do_work() call in on_activate()
    do_work() may call the function finish(), which will fail to deactivate
    the node if it is still in the on_activate callback.
  * Merge branch 'IntelligentRoboticsLabs:master' into master
  * Merge pull request #208 <https://github.com/IntelligentRoboticsLabs/ros2_planning_system/issues/208> from xydesa/plan-dotgraph-bug
    Plan dotgraph color bug
  * Merge branch 'IntelligentRoboticsLabs:master' into master
  * Removing unused variable.
  * More accurately getting the status of an action by including the action's start time in the index for coloring the dotgraph.
  * Contributors: Alexander Xydes, Francisco Martín Rico, Jake Keller, Josh Zapf

 -- Francisco Martin Rico <fmrico@gmail.com>  Mon, 02 May 2022 22:00:00 -0000

ros-iron-plansys2-executor (2.0.3-1jammy) jammy; urgency=high



 -- Francisco Martin Rico <fmrico@gmail.com>  Sat, 02 Apr 2022 22:00:00 -0000

ros-iron-plansys2-executor (2.0.2-1jammy) jammy; urgency=high

  * Use apply and check method to create action graph
  * plan-to-action-graph-mod: Using apply and check method to search for causal links.
  * generalize-is-parallelizable: Cleaning up comments a bit.
  * generalize-is-parallelizable: Checking for contradictions at any point in time in the is_parallelizable function.
  * generalize-is-parallelizable: Improving human readability.


=== debian/control ===
Source: ros-iron-plansys2-executor
Section: misc
Priority: optional
Maintainer: Francisco Martin Rico <fmrico@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libzmq3-dev, ros-iron-ament-cmake, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-index-cpp, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-behaviortree-cpp-v3, ros-iron-lifecycle-msgs, ros-iron-plansys2-core, ros-iron-plansys2-domain-expert, ros-iron-plansys2-msgs, ros-iron-plansys2-pddl-parser, ros-iron-plansys2-planner, ros-iron-plansys2-problem-expert, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-action, ros-iron-rclcpp-cascade-lifecycle, ros-iron-rclcpp-lifecycle, ros-iron-std-msgs, ros-iron-std-srvs, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-plansys2-executor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libzmq3-dev, ros-iron-ament-index-cpp, ros-iron-behaviortree-cpp-v3, ros-iron-lifecycle-msgs, ros-iron-plansys2-core, ros-iron-plansys2-domain-expert, ros-iron-plansys2-msgs, ros-iron-plansys2-pddl-parser, ros-iron-plansys2-planner, ros-iron-plansys2-problem-expert, ros-iron-pluginlib, ros-iron-popf, ros-iron-rclcpp, ros-iron-rclcpp-action, ros-iron-rclcpp-cascade-lifecycle, ros-iron-rclcpp-lifecycle, ros-iron-std-msgs, ros-iron-std-srvs, ros-iron-ros-workspace
Description: This package contains the Executor module for the ROS2 Planning System

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-plansys2-executor//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
